HDU-1087-Super Jumping! Jumping! Jumping!(dp)

Super Jumping! Jumping! Jumping!


Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
 

Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
 

Output
For each case, print the maximum according to rules, and one line one case.
 

Sample Input
 
 
3 1 3 24 1 2 3 44 3 3 2 10
 
Sample Output
 
 
4103

#include<bits/stdc++.h>
using namespace std;
int a[1005];
int dp[1005];///当处于编号为i时的最大值
int main()
{
    int n,sum,k,Max;
    while(1)
    {
        Max=0;
        scanf("%d",&n);
        if(n==0)break;
        for(int i=0;i<n;i++)
        {
            scanf("%d",&a[i]);
            dp[i]=a[i];///初始化dp数组,使数组初始时为本身,因比较的是当前最大价值和dp[j]的最大价值加上a[i];
        }
        for(int i=0;i<n;i++)///后
        {
            for(int j=0;j<i;j++)///前
            {
                if(a[i]>a[j])///如果后面的值大于前面的值
                dp[i]=max(dp[i],dp[j]+a[i]);///当前最大价值和dp[j]的最大价值加上a[i];
            }
            Max=max(dp[i],Max);
        }
        printf("%d\n",Max);
    }
    return 0;
}
求最大递增子序列,找到每一个点时的最大值,从所以点中找最大值,即为结果。第一个循环为每一个点,也就是后面的那个数所在的位置的dp[i],和前面的数j的dp[j]+a[i]相比较。结果为,当前位置能达到的最大值。

  • 1
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值